unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, StdCtrls, ExtCtrls;

const
  TextFileName = 'findtext.txt';

type

  { TForm1 }

  TForm1 = class(TForm)
    FindButton: TButton;
    TextFileMemo: TMemo;
    ParsedWordsMemo: TMemo;
    Panel1: TPanel;
    procedure FindButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FFakeKeys, FKeywords: TStringArray;
    procedure ParseKeywords;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FindButtonClick(Sender: TObject);
begin
  ParseKeywords;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TextFileMemo.Lines.LoadFromFile(TextFileName);
  FFakeKeys := TStringArray.Create('int ', 'double ', 'string ','bool ');
  FKeywords := TStringArray.Create('int', 'double', 'string','bool');
end;

procedure TForm1.ParseKeywords;
const
  AlphaNumSet: TSysCharSet = ['a'..'z','A'..'Z','0'..'9']; // set this to suit your needs
var
  lineCount: Integer;

  procedure Parse(const aString: String);
  var
    p: SizeInt;
    fkw: String;
    i: Integer;

    function GetFollower: String;
    var
      f, pf: Integer;
    begin
      f := p + Length(fkw);
      while (f < Length(aString)) and (aString[f] in [' ', #9]) do  // remove whitespace
        Inc(f);
      pf := f;
      while (pf < Length(aString)) and (aString[pf] in AlphaNumSet) do
        Inc(pf);
      Result := Copy(aString, f, pf - f);
    end;

  begin
    for i := 0 to High(FFakeKeys) do
      begin
        fkw := FFakeKeys[i];
        p := Pos(fkw, aString);
        if p > 0 then
          ParsedWordsMemo.Lines.Add('In line %d "%s" is at position %d; the following word is "%s"',[Succ(lineCount), FKeywords[i], p, GetFollower]);
      end;
  end;

begin
  ParsedWordsMemo.Lines.Clear;
  for lineCount := 0 to TextFileMemo.Lines.Count-1 do
      Parse(TextFileMemo.Lines[lineCount]);
end;

end.
